'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/* @flow */

exports.default = function (_ref) {
  var t = _ref.types;

  function isMeteorModuleArg(moduleArg) {
    return moduleArg && moduleArg.type === 'StringLiteral' && /^meteor\/[-a-zA-Z0-9_]+/.test(moduleArg.value);
  }

  function memberExpressionForMeteorModuleArg(moduleArg) {
    return ['Package'].concat(_toConsumableArray(moduleArg.value.split(/\//g))).map(function (part) {
      return t.identifier(part);
    }).reduce(function (object, property) {
      return t.memberExpression(object, property);
    });
  }

  function transformRequireCall(nodePath, state) {
    if (!t.isIdentifier(nodePath.node.callee, { name: 'require' }) && !(t.isMemberExpression(nodePath.node.callee) && t.isIdentifier(nodePath.node.callee.object, { name: 'require' }))) {
      return;
    }

    var moduleArg = nodePath.node.arguments[0];
    if (isMeteorModuleArg(moduleArg)) {
      nodePath.replaceWith(memberExpressionForMeteorModuleArg(moduleArg));
    }
  }

  function transformImportCall(nodePath, state) {
    var moduleArg = nodePath.node.source;
    if (isMeteorModuleArg(moduleArg)) {
      nodePath.node.specifiers.forEach(function (specifier) {
        if (specifier.type === 'ImportDefaultSpecifier') {
          throw new Error("invalid default import from a meteor package");
        }
      });
      nodePath.replaceWith(t.variableDeclaration('const', [t.variableDeclarator(t.objectPattern(nodePath.node.specifiers.map(function (specifier) {
        return t.objectProperty(specifier.imported, specifier.local);
      })), memberExpressionForMeteorModuleArg(moduleArg))]));
    }
  }

  return {
    visitor: {
      CallExpression: {
        exit: function exit(nodePath, state) {
          return transformRequireCall(nodePath, state);
        }
      },
      ImportDeclaration: {
        exit: function exit(nodePath, state) {
          return transformImportCall(nodePath, state);
        }
      }
    }
  };
};